| API Docs for SAX and DOM |

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# DOMDocument Class Reference

The `DOMDocument` interface represents the entire XML document. More...

`#include <DOMDocument.hpp>`

Inheritance diagram for DOMDocument

[legend]
Collaboration diagram for DOMDocument:

[legend]
List of all members.

## Public Methods

Destructor
virtual | ~DOMDocument ()
| Destructor.
Functions introduced in DOM Level 1
virtual DOMElement* | createElement (const XMLCh *tagName)=0
| Creates an element of the type specified. More...
virtual DOMDocumentFragment* | createDocumentFragment ()=0
| Creates an empty `DOMDocumentFragment` object. More...
virtual DOMText* | createTextNode (const XMLCh *data)=0
| Creates a `DOMText` node given the specified string. More...
virtual DOMComment* | createComment (const XMLCh *data)=0
| Creates a `DOMComment` node given the specified string. More...
virtual DOMCDATASection* | createCDATASection (const XMLCh *data)=0
| Creates a `DOMCDATASection` node whose value is the specified string. More...
virtual DOMProcessingInstruction* | createProcessingInstruction (const XMLCh *target,const XMLCh *data)=0
| Creates a `DOMProcessingInstruction` node given the specified name and data strings. More...
virtual DOMAttr* | createAttribute (const XMLCh *name)=0
| Creates an `DOMAttr` of the given name. More...
virtual DOMEntityReference* | createEntityReference (const XMLCh *name)=0
| Creates an `DOMEntityReference` object. More...
virtual DOMDocumentType* | getDoctype ()const=0
| The Document Type Declaration (see `DOMDocumentType`) associated with this document. More...
virtual DOMImplementation* | getImplementation ()const=0
| The `DOMImplementation` object that handles this document. More...
virtual DOMElement* | getDocumentElement ()const=0
| This is a convenience attribute that allows direct access to the child node that is the root element of the document. More...
virtual DOMNodeList* | getElementsByTagName (const XMLCh *tagname)const=0
| Returns a `DOMNodeList` of all the `DOMElement(s)` with a given tag name in the order in which they are encountered in a preorder traversal of the `DOMDocument` tree. More...
Functions introduced in DOM Level 2.
virtual DOMNode* | importNode (DOMNode *importedNode,bool deep)=0
| Imports a node from another document to this document. More...
virtual DOMElement* | createElementNS (const XMLCh *namespaceURI,const XMLCh *qualifiedName)=0
| Creates an element of the given qualified name and namespace URI. More...
virtual DOMAttr* | createAttributeNS (const XMLCh *namespaceURI,const XMLCh *qualifiedName)=0
| Creates an attribute of the given qualified name and namespace URI. More...
virtual DOMNodeList* | getElementsByTagNameNS (const XMLCh *namespaceURI,const XMLCh *localName)const=0
| Returns a `DOMNodeList` of all the `DOMElement(s)` with a given local name and namespace URI in the order in which they are encountered in a preorder traversal of the `DOMDocument` tree. More...
virtual DOMElement* | getElementById (const XMLCh *elementId)const=0
| Returns the `DOMElement` whose `ID` is given by `elementId`. More...
Functions introduced in DOM Level 3.
virtual const XMLCh* | getActualEncoding ()const=0
| An attribute specifying the actual encoding of this document. More...
virtual void | setActualEncoding (const XMLCh *actualEncoding)=0
| An attribute specifying the actual encoding of this document. More...
virtual const XMLCh* | getEncoding ()const=0
| An attribute specifying, as part of the XML declaration, the encoding of this document. More...
virtual void | setEncoding (const XMLCh *encoding)=0
| An attribute specifying, as part of the XML declaration, the encoding of this document. More...
virtual bool | getStandalone ()const=0
| An attribute specifying, as part of the XML declaration, whether this document is standalone. More...
virtual void | setStandalone (bool standalone)=0
| An attribute specifying, as part of the XML declaration, whether this document is standalone. More...
virtual const XMLCh* | getVersion ()const=0
| An attribute specifying, as part of the XML declaration, the version number of this document. More...
virtual void | setVersion (const XMLCh *version)=0
| An attribute specifying, as part of the XML declaration, the version number of this document. More...
virtual const XMLCh* | getDocumentURI ()const=0
| The location of the document or `null` if undefined. More...
virtual void | setDocumentURI (const XMLCh *documentURI)=0
| The location of the document or `null` if undefined. More...
virtual bool | getStrictErrorChecking ()const=0
| An attribute specifying whether errors checking is enforced or not. More...
virtual void | setStrictErrorChecking (bool strictErrorChecking)=0
| An attribute specifying whether errors checking is enforced or not. More...
virtual DOMErrorHandler* | getErrorHandler ()const=0
| This attribute allows applications to specify a `DOMErrorHandler` to be called in the event that an error is encountered while performing an operation on a document. More...
virtual void | setErrorHandler (DOMErrorHandler *const handler)=0
| This attribute allows applications to specify a `DOMErrorHandler` to be called in the event that an error is encountered while performing an operation on a document. More...
virtual DOMNode* | renameNode (DOMNode *n,const XMLCh *namespaceURI,const XMLCh *name)=0
| Rename an existing node. More...
virtual DOMNode* | adoptNode (DOMNode *source)=0
| Changes the `ownerDocument` of a node, its children, as well as the attached attribute nodes if there are any. More...
virtual void | normalizeDocument ()=0
| This method acts as if the document was going through a save and load cycle, putting the document in a "normal" form. More...
virtual bool | canSetNormalizationFeature (const XMLCh *const name,bool state)const=0
| Query whether setting a feature to a specific value is supported. More...
virtual void | setNormalizationFeature (const XMLCh *const name,bool state)=0
| Set the state of a feature.Need to specify the list of features. More...
virtual bool | getNormalizationFeature (const XMLCh *const name)const=0
| Look up the value of a feature. More...
Non-standard extension
virtual DOMEntity* | createEntity (const XMLCh *name)=0
| Non-standard extension. More...
virtual DOMDocumentType* | createDocumentType (const XMLCh *name)=0
| Non-standard extension. More...
virtual DOMNotation* | createNotation (const XMLCh *name)=0
| Non-standard extension. More...
virtual DOMElement* | createElementNS (const XMLCh *namespaceURI,const XMLCh *qualifiedName,const XMLSSize_t lineNum,const XMLSSize_t columnNum)=0
| Non-standard extension. More...

## Protected Methods

Hidden constructors
| DOMDocument ()
| DOMDocument (const DOMDocument &)
DOMDocument& | operator= (const DOMDocument &)

## Friends

class | DOMNode
class | DOMImplementation

## Detailed Description

The `DOMDocument` interface represents the entire XML document.

Conceptually, it is the root of the document tree, and provides the primary access to the document's data.

Since elements, text nodes, comments, processing instructions, etc. cannot exist outside the context of a `DOMDocument`, the `DOMDocument` interface also contains the factory methods needed to create these objects. The `DOMNode` objects created have a `ownerDocument` attribute which associates them with the `DOMDocument` within whose context they were created.

See also the Document Object Model (DOM) Level 2 Core Specification.

## Constructor & Destructor Documentation

DOMDocument::DOMDocument ( | )`[protected]`

DOMDocument::DOMDocument ( | const DOMDocument & )`[protected]`

DOMDocument::~DOMDocument ( | )`[virtual]`

| Destructor.

## Member Function Documentation

DOMNode * DOMDocument::adoptNode ( | DOMNode * source )`[pure virtual]`

Changes the `ownerDocument` of a node, its children, as well as the attached attribute nodes if there are any.

If the node has a parent it is first removed from its parent child list. This effectively allows moving a subtree from one document to another. The following list describes the specifics for each type of node.

"Experimental - subject to change"

ATTRIBUTE_NODE
  The `ownerElement` attribute is set to `null` and the `specified` flag is set to `true` on the adopted `DOMAttr`. The descendants of the source `DOMAttr` are recursively adopted.
DOCUMENT_FRAGMENT_NODE
  The descendants of the source node are recursively adopted.
DOCUMENT_NODE
  `DOMDocument` nodes cannot be adopted.
DOCUMENT_TYPE_NODE
  `DOMDocumentType` nodes cannot be adopted.
ELEMENT_NODE
  Specified attribute nodes of the source element are adopted, and the generated `DOMAttr` nodes. Default attributes are discarded, though if the document being adopted into defines default attributes for this element name, those are assigned. The descendants of the source element are recursively adopted.
ENTITY_NODE
  `DOMEntity` nodes cannot be adopted.
ENTITY_REFERENCE_NODE
  Only the `DOMEntityReference` node itself is adopted, the descendants are discarded, since the source and destination documents might have defined the entity differently. If the document being imported into provides a definition for this entity name, its value is assigned.
NOTATION_NODE
  `DOMNotation` nodes cannot be adopted.
PROCESSING_INSTRUCTION_NODE, TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE
  These nodes can all be adopted. No specifics.

Parameters:

  source | The node to move into this document.

Returns:
  The adopted node, or `null` if this operation fails, such as when the source node comes from a different implementation.

Exceptions:

  DOMException | NOT_SUPPORTED_ERR: Raised if the source node is of type `DOCUMENT`, `DOCUMENT_TYPE`. NO_MODIFICATION_ALLOWED_ERR: Raised when the source node is readonly.

Since:
  DOM Level 3

bool DOMDocument::canSetNormalizationFeature ( | const XMLCh *const name,
| bool state ) const`[pure virtual]`

Query whether setting a feature to a specific value is supported.

The feature name has the same form as a DOM `hasFeature` string.

"Experimental - subject to change"

Parameters:

  name | The name of the feature to check.
  state | The requested state of the feature (`true` or `false`).

Returns:
  `true` if the feature could be successfully set to the specified value, or `false` if the feature is not recognized or the requested value is not supported. This does not change the current value of the feature itself.

Since:
  DOM Level 3

DOMAttr * DOMDocument::createAttribute ( | const XMLCh * name )`[pure virtual]`

Creates an `DOMAttr` of the given name.

Note that the `DOMAttr` instance can then be set on an `DOMElement` using the `setAttributeNode` method.
To create an attribute with a qualified name and namespace URI, use the `createAttributeNS` method.

Parameters:

  name | The name of the attribute.

Returns:
  A new `DOMAttr` object with the `nodeName` attribute set to `name`, and `localName`, `prefix`, and `namespaceURI` set to `null`. The value of the attribute is the empty string.

Exceptions:

  DOMException | INVALID_CHARACTER_ERR: Raised if the specified name contains an illegal character.

Since:
  DOM Level 1

DOMAttr * DOMDocument::createAttributeNS ( | const XMLCh * namespaceURI,
| const XMLCh * qualifiedName )`[pure virtual]`

Creates an attribute of the given qualified name and namespace URI.

Parameters:

  namespaceURI | The namespace URI of the attribute to create.
  qualifiedName | The qualified name of the attribute to instantiate.

Returns:
  A new `DOMAttr` object with the following attributes:

  `Attribute` | `Value`
  `DOMNode.nodeName` | qualifiedName
  `DOMNode.namespaceURI` | `namespaceURI`
  `DOMNode.prefix` | prefix, extracted from `qualifiedName`, or `null` if there is no prefix
  `DOMNode.localName` | local name, extracted from `qualifiedName`
  `DOMAttr.name` | `qualifiedName`
  `DOMNode.nodeValue` | the empty string

Exceptions:

  DOMException

  INVALID_CHARACTER_ERR: Raised if the specified qualified name contains an illegal character, per the XML 1.0 specification .
  NAMESPACE_ERR: Raised if the `qualifiedName` is malformed per the Namespaces in XML specification, if the `qualifiedName` has a prefix and the `namespaceURI` is `null`, if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from " http://www.w3.org/XML/1998/namespace", or if the `qualifiedName`, or its prefix, is "xmlns" and the `namespaceURI` is different from " http://www.w3.org/2000/xmlns/".
  NOT_SUPPORTED_ERR: Always thrown if the current document does not support the `"XML"` feature, since namespaces were defined by XML.

Since:
  DOM Level 2

DOMCDATASection * DOMDocument::createCDATASection ( | const XMLCh * data )`[pure virtual]`

Creates a `DOMCDATASection` node whose value is the specified string.

Parameters:

  data | The data for the `DOMCDATASection` contents.

Returns:
  The new `DOMCDATASection` object.

Since:
  DOM Level 1

DOMComment * DOMDocument::createComment ( | const XMLCh * data )`[pure virtual]`

Creates a `DOMComment` node given the specified string.

Parameters:

  data | The data for the node.

Returns:
  The new `DOMComment` object.

Since:
  DOM Level 1

DOMDocumentFragment * DOMDocument::createDocumentFragment ( | )`[pure virtual]`

Creates an empty `DOMDocumentFragment` object.

Returns:
  A new `DOMDocumentFragment`.

Since:
  DOM Level 1

DOMDocumentType * DOMDocument::createDocumentType ( | const XMLCh * name )`[pure virtual]`

Non-standard extension.

Create a DOMDocumentType node.

Returns:
  A `DOMDocumentType` that references the newly created DOMDocumentType node.

DOMElement * DOMDocument::createElement ( | const XMLCh * tagName )`[pure virtual]`

Creates an element of the type specified.

Note that the instance returned implements the `DOMElement` interface, so attributes can be specified directly on the returned object.
In addition, if there are known attributes with default values, `DOMAttr` nodes representing them are automatically created and attached to the element.
To create an element with a qualified name and namespace URI, use the `createElementNS` method.

Parameters:

  tagName | The name of the element type to instantiate. For XML, this is case-sensitive.

Returns:
  A new `DOMElement` object with the `nodeName` attribute set to `tagName`, and `localName`, `prefix`, and `namespaceURI` set to `null`.

Exceptions:

  DOMException | INVALID_CHARACTER_ERR: Raised if the specified name contains an illegal character.

Since:
  DOM Level 1

DOMElement * DOMDocument::createElementNS ( | const XMLCh * namespaceURI,
| const XMLCh * qualifiedName,
| const XMLSSize_t lineNum,
| const XMLSSize_t columnNum )`[pure virtual]`

Non-standard extension.

Creates an element of the given qualified name and namespace URI, and also stores line/column number info. Used by internally XSDXercesDOMParser during schema traversal.

See also:
  createElementNS(const XMLCh *namespaceURI, const XMLCh *qualifiedName)

DOMElement * DOMDocument::createElementNS ( | const XMLCh * namespaceURI,
| const XMLCh * qualifiedName )`[pure virtual]`

Creates an element of the given qualified name and namespace URI.

Parameters:

  namespaceURI | The namespace URI of the element to create.
  qualifiedName | The qualified name of the element type to instantiate.

Returns:
  A new `DOMElement` object with the following attributes:

  `Attribute` | `Value`
  `DOMNode.nodeName` | `qualifiedName`
  `DOMNode.namespaceURI` | `namespaceURI`
  `DOMNode.prefix` | prefix, extracted from `qualifiedName`, or `null` if there is no prefix
  `DOMNode.localName` | local name, extracted from `qualifiedName`
  `DOMElement.tagName` | `qualifiedName`

Exceptions:

  DOMException

  INVALID_CHARACTER_ERR: Raised if the specified qualified name contains an illegal character, per the XML 1.0 specification .
  NAMESPACE_ERR: Raised if the `qualifiedName` is malformed per the Namespaces in XML specification, if the `qualifiedName` has a prefix and the `namespaceURI` is `null`, or if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from " http://www.w3.org/XML/1998/namespace" .
  NOT_SUPPORTED_ERR: Always thrown if the current document does not support the `"XML"` feature, since namespaces were defined by XML.

Since:
  DOM Level 2

DOMEntity * DOMDocument::createEntity ( | const XMLCh * name )`[pure virtual]`

Non-standard extension.

Create a new entity.

Parameters:

  name | The name of the entity to instantiate

DOMEntityReference * DOMDocument::createEntityReference ( | const XMLCh * name )`[pure virtual]`

Creates an `DOMEntityReference` object.

In addition, if the referenced entity is known, the child list of the `DOMEntityReference` node is made the same as that of the corresponding `DOMEntity` node.If any descendant of the `DOMEntity` node has an unbound namespace prefix, the corresponding descendant of the created `DOMEntityReference` node is also unbound; (its `namespaceURI` is `null`). The DOM Level 2 does not support any mechanism to resolve namespace prefixes.

Parameters:

  name | The name of the entity to reference.

Returns:
  The new `DOMEntityReference` object.

Exceptions:

  DOMException | INVALID_CHARACTER_ERR: Raised if the specified name contains an illegal character.

Since:
  DOM Level 1

DOMNotation * DOMDocument::createNotation ( | const XMLCh * name )`[pure virtual]`

Non-standard extension.

Create a Notation.

Parameters:

  name | The name of the notation to instantiate

Returns:
  A `DOMNotation` that references the newly created DOMNotation node.

DOMProcessingInstruction * DOMDocument::createProcessingInstruction ( | const XMLCh * target,
| const XMLCh * data )`[pure virtual]`

Creates a `DOMProcessingInstruction` node given the specified name and data strings.

Parameters:

  target | The target part of the processing instruction.
  data | The data for the node.

Returns:
  The new `DOMProcessingInstruction` object.

Exceptions:

  DOMException | INVALID_CHARACTER_ERR: Raised if the specified target contains an illegal character.

Since:
  DOM Level 1

DOMText * DOMDocument::createTextNode ( | const XMLCh * data )`[pure virtual]`

Creates a `DOMText` node given the specified string.

Parameters:

  data | The data for the node.

Returns:
  The new `DOMText` object.

Since:
  DOM Level 1

const XMLCh * DOMDocument::getActualEncoding ( | ) const`[pure virtual]`

An attribute specifying the actual encoding of this document.

This is `null` otherwise.
This attribute represents the property [character encoding scheme] defined in.

"Experimental - subject to change"

Since:
  DOM Level 3

DOMDocumentType * DOMDocument::getDoctype ( | ) const`[pure virtual]`

The Document Type Declaration (see `DOMDocumentType`) associated with this document.

For XML documents without a document type declaration this returns `null`. The DOM Level 2 does not support editing the Document Type Declaration. `docType` cannot be altered in any way, including through the use of methods inherited from the `DOMNode` interface, such as `insertNode` or `removeNode`.

Since:
  DOM Level 1

DOMElement * DOMDocument::getDocumentElement ( | ) const`[pure virtual]`

This is a convenience attribute that allows direct access to the child node that is the root element of the document.

Since:
  DOM Level 1

const XMLCh * DOMDocument::getDocumentURI ( | ) const`[pure virtual]`

The location of the document or `null` if undefined.

Beware that when the `DOMDocument` supports the feature "HTML" , the href attribute of the HTML BASE element takes precedence over this attribute.

"Experimental - subject to change"

Since:
  DOM Level 3

DOMElement * DOMDocument::getElementById ( | const XMLCh * elementId ) const`[pure virtual]`

Returns the `DOMElement` whose `ID` is given by `elementId`.

If no such element exists, returns `null`. Behavior is not defined if more than one element has this `ID`. The DOM implementation must have information that says which attributes are of type ID. Attributes with the name "ID" are not of type ID unless so defined. Implementations that do not know whether attributes are of type ID or not are expected to return `null`.

Parameters:

  elementId | The unique `id` value for an element.

Returns:
  The matching element.

Since:
  DOM Level 2

DOMNodeList * DOMDocument::getElementsByTagName ( | const XMLCh * tagname ) const`[pure virtual]`

Returns a `DOMNodeList` of all the `DOMElement(s)` with a given tag name in the order in which they are encountered in a preorder traversal of the `DOMDocument` tree.

The returned node list is "live", in that changes to the document tree made after a nodelist was initially returned will be immediately reflected in the node list.

Parameters:

  tagname | The name of the tag to match on. The special value "*" matches all tags.

Returns:
  A new `DOMNodeList` object containing all the matched `DOMElement(s)`.

Since:
  DOM Level 1

DOMNodeList * DOMDocument::getElementsByTagNameNS ( | const XMLCh * namespaceURI,
| const XMLCh * localName ) const`[pure virtual]`

Returns a `DOMNodeList` of all the `DOMElement(s)` with a given local name and namespace URI in the order in which they are encountered in a preorder traversal of the `DOMDocument` tree.

Parameters:

  namespaceURI | The namespace URI of the elements to match on. The special value "*" matches all namespaces.
  localName | The local name of the elements to match on. The special value "*" matches all local names.

Returns:
  A new `DOMNodeList` object containing all the matched `DOMElement(s)`.

Since:
  DOM Level 2

const XMLCh * DOMDocument::getEncoding ( | ) const`[pure virtual]`

An attribute specifying, as part of the XML declaration, the encoding of this document.

This is `null` when unspecified.

"Experimental - subject to change"

Since:
  DOM Level 3

DOMErrorHandler * DOMDocument::getErrorHandler ( | ) const`[pure virtual]`

This attribute allows applications to specify a `DOMErrorHandler` to be called in the event that an error is encountered while performing an operation on a document.

Note that not all methods use this mechanism, see the description of each method for details.

"Experimental - subject to change"

Since:
  DOM Level 3

DOMImplementation * DOMDocument::getImplementation ( | ) const`[pure virtual]`

The `DOMImplementation` object that handles this document.

A DOM application may use objects from multiple implementations.

Since:
  DOM Level 1

bool DOMDocument::getNormalizationFeature ( | const XMLCh *const name ) const`[pure virtual]`

Look up the value of a feature.

The feature name has the same form as a DOM `hasFeature` string. The recognized features are the same as the ones defined for `setNormalizationFeature`.

"Experimental - subject to change"

Parameters:

  name | The name of the feature to look up.

Returns:
  The current state of the feature (`true` or `false`).

Exceptions:

  DOMException | NOT_FOUND_ERR: Raised when the feature name is not recognized.

Since:
  DOM Level 3

bool DOMDocument::getStandalone ( | ) const`[pure virtual]`

An attribute specifying, as part of the XML declaration, whether this document is standalone.

This attribute represents the property [standalone] defined in .

"Experimental - subject to change"

Since:
  DOM Level 3

bool DOMDocument::getStrictErrorChecking ( | ) const`[pure virtual]`

An attribute specifying whether errors checking is enforced or not.

When set to `false`, the implementation is free to not test every possible error case normally defined on DOM operations, and not raise any `DOMException`. In case of error, the behavior is undefined. This attribute is `true` by defaults.

"Experimental - subject to change"

Since:
  DOM Level 3

const XMLCh * DOMDocument::getVersion ( | ) const`[pure virtual]`

An attribute specifying, as part of the XML declaration, the version number of this document.

This is `null` when unspecified.
This attribute represents the property [version] defined in .

"Experimental - subject to change"

Since:
  DOM Level 3

DOMNode * DOMDocument::importNode ( | DOMNode * importedNode,
| bool deep )`[pure virtual]`

Imports a node from another document to this document.

The returned node has no parent; (`parentNode` is `null`). The source node is not altered or removed from the original document; this method creates a new copy of the source node.
For all nodes, importing a node creates a node object owned by the importing document, with attribute values identical to the source node's `nodeName` and `nodeType`, plus the attributes related to namespaces (`prefix`, `localName`, and `namespaceURI`). As in the `cloneNode` operation on a `DOMNode`, the source node is not altered.
Additional information is copied as appropriate to the `nodeType`, attempting to mirror the behavior expected if a fragment of XML source was copied from one document to another, recognizing that the two documents may have different DTDs in the XML case. The following list describes the specifics for each type of node.

ATTRIBUTE_NODE
  The `ownerElement` attribute is set to `null` and the `specified` flag is set to `true` on the generated `DOMAttr`. The descendants of the source `DOMAttr` are recursively imported and the resulting nodes reassembled to form the corresponding subtree. Note that the `deep` parameter has no effect on `DOMAttr` nodes; they always carry their children with them when imported.
DOCUMENT_FRAGMENT_NODE
  If the `deep` option was set to `true`, the descendants of the source element are recursively imported and the resulting nodes reassembled to form the corresponding subtree. Otherwise, this simply generates an empty `DOMDocumentFragment`.
DOCUMENT_NODE
  `DOMDocument` nodes cannot be imported.
DOCUMENT_TYPE_NODE
  `DOMDocumentType` nodes cannot be imported.
ELEMENT_NODE
  Specified attribute nodes of the source element are imported, and the generated `DOMAttr` nodes are attached to the generated `DOMElement`. Default attributes are not copied, though if the document being imported into defines default attributes for this element name, those are assigned. If the `importNode` `deep` parameter was set to `true`, the descendants of the source element are recursively imported and the resulting nodes reassembled to form the corresponding subtree.
ENTITY_NODE
  `DOMEntity` nodes can be imported, however in the current release of the DOM the `DOMDocumentType` is readonly. Ability to add these imported nodes to a `DOMDocumentType` will be considered for addition to a future release of the DOM.On import, the `publicId`, `systemId`, and `notationName` attributes are copied. If a `deep` import is requested, the descendants of the the source `DOMEntity` are recursively imported and the resulting nodes reassembled to form the corresponding subtree.
ENTITY_REFERENCE_NODE
  Only the `DOMEntityReference` itself is copied, even if a `deep` import is requested, since the source and destination documents might have defined the entity differently. If the document being imported into provides a definition for this entity name, its value is assigned.
NOTATION_NODE
  `DOMNotation` nodes can be imported, however in the current release of the DOM the `DOMDocumentType` is readonly. Ability to add these imported nodes to a `DOMDocumentType` will be considered for addition to a future release of the DOM.On import, the `publicId` and `systemId` attributes are copied. Note that the `deep` parameter has no effect on `DOMNotation` nodes since they never have any children.
PROCESSING_INSTRUCTION_NODE
  The imported node copies its `target` and `data` values from those of the source node.
TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE
  These three types of nodes inheriting from `DOMCharacterData` copy their `data` and `length` attributes from those of the source node.

Parameters:

  importedNode | The node to import.
  deep | If `true`, recursively import the subtree under the specified node; if `false`, import only the node itself, as explained above. This has no effect on `DOMAttr` , `DOMEntityReference`, and `DOMNotation` nodes.

Returns:
  The imported node that belongs to this `DOMDocument`.

Exceptions:

  DOMException | NOT_SUPPORTED_ERR: Raised if the type of node being imported is not supported.

Since:
  DOM Level 2

void DOMDocument::normalizeDocument ( | )`[pure virtual]`

This method acts as if the document was going through a save and load cycle, putting the document in a "normal" form.

The actual result depends on the features being set and governing what operations actually take place. See `setNormalizationFeature` for details.

"Experimental - subject to change"

Noticeably this method normalizes `DOMText` nodes, makes the document "namespace wellformed", according to the algorithm described below in pseudo code, by adding missing namespace declaration attributes and adding or changing namespace prefixes, updates the replacement tree of `DOMEntityReference` nodes, normalizes attribute values, etc.
Mutation events, when supported, are generated to reflect the changes occuring on the document.

Since:
  DOM Level 3

DOMDocument & DOMDocument::operator= ( | const DOMDocument & )`[protected]`

DOMNode * DOMDocument::renameNode ( | DOMNode * n,
| const XMLCh * namespaceURI,
| const XMLCh * name )`[pure virtual]`

Rename an existing node.

When possible this simply changes the name of the given node, otherwise this creates a new node with the specified name and replaces the existing node with the new node as described below. This only applies to nodes of type `ELEMENT_NODE` and `ATTRIBUTE_NODE`.
When a new node is created, the following operations are performed: the new node is created, any registered event listener is registered on the new node, any user data attached to the old node is removed from that node, the old node is removed from its parent if it has one, the children are moved to the new node, if the renamed node is an `DOMElement` its attributes are moved to the new node, the new node is inserted at the position the old node used to have in its parent's child nodes list if it has one, the user data that was attached to the old node is attach to the new node, the user data event `NODE_RENAMED` is fired.
When the node being renamed is an `DOMAttr` that is attached to an `DOMElement`, the node is first removed from the `DOMElement` attributes map. Then, once renamed, either by modifying the existing node or creating a new one as described above, it is put back.

"Experimental - subject to change"

Parameters:

  n | The node to rename.
  namespaceURI | The new namespaceURI.
  name | The new qualified name.

Returns:
  The renamed node. This is either the specified node or the new node that was created to replace the specified node.

Exceptions:

  DOMException

  NOT_SUPPORTED_ERR: Raised when the type of the specified node is neither `ELEMENT_NODE` nor `ATTRIBUTE_NODE`.
  WRONG_DOCUMENT_ERR: Raised when the specified node was created from a different document than this document.
  NAMESPACE_ERR: Raised if the `qualifiedName` is malformed per the Namespaces in XML specification, if the `qualifiedName` has a prefix and the `namespaceURI` is `null`, or if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from " http://www.w3.org/XML/1998/namespace" . Also raised, when the node being renamed is an attribute, if the `qualifiedName`, or its prefix, is "xmlns" and the `namespaceURI` is different from "http://www.w3.org/2000/xmlns/".

Since:
  DOM Level 3

void DOMDocument::setActualEncoding ( | const XMLCh * actualEncoding )`[pure virtual]`

An attribute specifying the actual encoding of this document.

This is `null` otherwise.
This attribute represents the property [character encoding scheme] defined in .

"Experimental - subject to change"

Since:
  DOM Level 3

void DOMDocument::setDocumentURI ( | const XMLCh * documentURI )`[pure virtual]`

The location of the document or `null` if undefined.

Beware that when the `DOMDocument` supports the feature "HTML" , the href attribute of the HTML BASE element takes precedence over this attribute.

"Experimental - subject to change"

Since:
  DOM Level 3

void DOMDocument::setEncoding ( | const XMLCh * encoding )`[pure virtual]`

An attribute specifying, as part of the XML declaration, the encoding of this document.

This is `null` when unspecified.

"Experimental - subject to change"

Since:
  DOM Level 3

void DOMDocument::setErrorHandler ( | DOMErrorHandler *const handler )`[pure virtual]`

This attribute allows applications to specify a `DOMErrorHandler` to be called in the event that an error is encountered while performing an operation on a document.

Note that not all methods use this mechanism, see the description of each method for details.

"Experimental - subject to change"

Since:
  DOM Level 3

void DOMDocument::setNormalizationFeature ( | const XMLCh *const name,
| bool state )`[pure virtual]`

Set the state of a feature.Need to specify the list of features.

Feature names are valid XML names. Implementation specific features (extensions) should choose an implementation specific prefix to avoid name collisions. The following lists feature names that are recognized by all implementations. However, it is sometimes possible for a `DOMDocument` to recognize a feature but not to support setting its value. The following list of recognized features indicates the definitions of each feature state, if setting the state to `true` or `false` must be supported or is optional and, which state is the default one:

"Experimental - subject to change"

`"canonical-form"`
  `true`
    [optional]Canonicalize the document according to the rules specified in . Note that this is limited to what can be represented in the DOM. In particular, there is no way to specify the order of the attributes in the DOM.
  `false`
    [required] (default)Do not canonicalize the document.
`"cdata-sections"`
  `true`
    [required] (default)Keep `CDATASection` nodes in the document.Name does not work really well in this case. ALH suggests renaming this to "cdata-sections". It works for both load and save.Renamed as suggested. (Telcon 27 Jan 2002).
  `false`
    [optional]Transform `CDATASection` nodes in the document into `DOMText` nodes. The new `DOMText` node is then combined with any adjacent `DOMText` node.
`"comments"`
  `true`
    [ required] (default)Keep `DOMComment` nodes in the document.
  `false`
    [required]Discard `Comment` nodes in the Document.
`DOM"datatype-normalization"`
  `true`
    [ required]Let the validation process do its datatype normalization that is defined in the used schema language. Note that this does not affect the DTD normalization operation which always takes place, in accordance to .We should define "datatype normalization".DTD normalization always apply because it's part of XML 1.0. Clarify the spec. (Telcon 27 Jan 2002).
  `false`
    [required] (default) Disable datatype normalization. The XML 1.0 attribute value normalization always occurs though.
`"discard-default-content"`
  `true`
    [required] ( default)Use whatever information available to the implementation (i.e. XML schema, DTD, the `specified` flag on `DOMAttr` nodes, and so on) to decide what attributes and content should be discarded or not. Note that the `specified` flag on `DOMAttr` nodes in itself is not always reliable, it is only reliable when it is set to `false` since the only case where it can be set to `false` is if the attribute was created by the implementation. The default content won't be removed if an implementation does not have any information available.
  `false`
    [required]Keep all attributes and all content.
`"entities"`
  `true`
    [ required] (default)Keep `DOMEntityReference` and `DOMEntity` nodes in the document.
  `false`
    [optional]Remove all `DOMEntityReference` and `DOMEntity` nodes from the document, putting the entity expansions directly in their place. `DOMText` nodes are into "normal" form. Only `DOMEntityReference` nodes to non-defined entities are kept in the document.
`"infoset"`
  `true`
    [optional]Only keep in the document the information defined in the XML Information Set .This forces the following features to `false`: `namespace-declarations`, `validate-if-schema`, `entities`, `cdata-sections`.This forces the following features to `true`: `datatype-normalization`, `whitespace-in-element-content`, `comments`. Other features are not changed unless explicity specified in the description of the features. Note that querying this feature with `getFeature` returns `true` only if the individual features specified above are appropriately set.Name doesn't work well here. ALH suggests renaming this to limit-to-infoset or match-infoset, something like that.Renamed 'infoset' (Telcon 27 Jan 2002).
  `false`
    Setting `infoset` to `false` has no effect.
`"namespace-declarations"`
  `true`
    [required] ( default)Include namespace declaration attributes, specified or defaulted from the schema or the DTD, in the document. See also the section Declaring Namespaces in .
  `false`
    [optional]Discard all namespace declaration attributes. The Namespace prefixes are retained even if this feature is set to `false`.
`"normalize-characters"`
  `true`
    [optional]Perform the W3C Text Normalization of the characters in the document.
  `false`
    [required] (default)Do not perform character normalization.
`"split-cdata-sections"`
  `true`
    [ required] (default)Split CDATA sections containing the CDATA section termination marker ']]&gt;'. When a CDATA section is split a warning is issued.
  `false`
    [required]Signal an error if a `DOMCDATASection` contains an unrepresentable character.
`"validate"`
  `true`
    [optional]Require the validation against a schema (i.e. XML schema, DTD, , any other type or representation of schema) of the document as it is being normalized as defined by . If validation errors are found, or no schema was found, the error handler is notified. Note also that no datatype normalization (i.e. non-XML 1.0 normalization) is done according to the schema used unless the feature `datatype-normalization` is `true`. `validate-if-schema` and `validate` are mutually exclusive, setting one of them to `true` will set the other one to `false`.
  `false`
    [required] ( default) Only XML 1.0 non-validating processing must be done. Note that validation might still happen if `validate-if-schema` is `true`.
`"validate-if-schema"`
  `true`
    [optional]Enable validation only if a declaration for the document element can be found (independently of where it is found, i.e. XML schema, DTD, , or any other type or representation of schema). If validation errors are found, the error handler is notified. Note also that no datatype normalization (i.e. non-XML 1.0 normalization) is done according to the schema used unless the feature `datatype-normalization` is `true`. `validate-if-schema` and `validate` are mutually exclusive, setting one of them to `true` will set the other one to `false`.
  `false`
    [required] (default)No validation should be performed if the document has a schema. Note that validation must still happen if `validate` is `true`.
`"whitespace-in-element-content"`
  `true`
    [required] (default)Keep all white spaces in the document. How does this feature interact with `"validate"` and `Text.isWhitespaceInElementContent`.
  `false`
    [optional]Discard white space in element content while normalizing. The implementation is expected to use the `isWhitespaceInElementContent` flag on `Text` nodes to determine if a text node should be written out or not.

Parameters:

  name | The name of the feature to set.
  state | The requested state of the feature (`true` or `false`).

Exceptions:

  DOMException | NOT_SUPPORTED_ERR: Raised when the feature name is recognized but the requested value cannot be set. NOT_FOUND_ERR: Raised when the feature name is not recognized.

Since:
  DOM Level 3

void DOMDocument::setStandalone ( | bool standalone )`[pure virtual]`

An attribute specifying, as part of the XML declaration, whether this document is standalone.

This attribute represents the property [standalone] defined in .

"Experimental - subject to change"

Since:
  DOM Level 3

void DOMDocument::setStrictErrorChecking ( | bool strictErrorChecking )`[pure virtual]`

An attribute specifying whether errors checking is enforced or not.

When set to `false`, the implementation is free to not test every possible error case normally defined on DOM operations, and not raise any `DOMException`. In case of error, the behavior is undefined. This attribute is `true` by defaults.

"Experimental - subject to change"

Since:
  DOM Level 3

void DOMDocument::setVersion ( | const XMLCh * version )`[pure virtual]`

An attribute specifying, as part of the XML declaration, the version number of this document.

This is `null` when unspecified.
This attribute represents the property [version] defined in .

"Experimental - subject to change"

Since:
  DOM Level 3

## Friends And Related Function Documentation

class DOMImplementation`[friend]`

class DOMNode`[friend]`

The documentation for this class was generated from the following file:

- DOMDocument.hpp

Copyright © 2000 The Apache Software Foundation. All Rights Reserved.